<template>
  <div v-if="favorites_user">
    <div class="page-title">Favorites</div>
    <div class="grid-content">
      <div
        class="grid-item"
        v-for="(item, index) in favorites_user"
        :key="index"
      >
        <div
          class="grid-item__top"
          :class="{ 'none-photo': !item.user.media_files_in_search.length }"
        >
          <template v-if="item.user.media_files_in_search.length">
            <client-only>
              <swiper class="grid-item__gallery" :options="swiperMainOptions">
                <swiper-slide
                  v-for="(slide, index) in item.user.media_files_in_search"
                  :key="index"
                >
                  <div>
                    <blur-hash-image
                      v-if="slide.media_file.blurhash"
                      :hash="slide.media_file.blurhash"
                      :src="`/storage/${slide.media_file.preview_url}`"
                      class="blurhash"
                    />
                  </div>
                </swiper-slide>
                <div class="swiper-pagination" slot="pagination"></div>
              </swiper>
            </client-only>
          </template>
          <svg-icon v-else name="photo" />
        </div>
        <div class="grid-item__bottom">
          <div class="grid-item__title">
            <nuxt-link :to="localePath(`/users/${item.user.username}`)">
              {{ item.user.display_name }}
            </nuxt-link>
          </div>
          <div class="grid-item__place" v-if="item.user.location">
            <svg-icon name="marker" />
            <div>
              {{
                [item.user.location.city, item.user.location.country]
                  .filter(e => !!e)
                  .join(', ')
              }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@vue/composition-api'
import { useGetUserFavoritesQuery } from '@/sdk/hooks'

import { Swiper, SwiperSlide, directive } from 'vue-awesome-swiper'
import 'swiper/css/swiper.css'

export default defineComponent({
  name: 'FavoritesPage',
  components: { Swiper, SwiperSlide },
  directives: {
    swiper: directive
  },
  setup(_, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    const favorites_user = ref<any>([] as any)
    const { onResult } = useGetUserFavoritesQuery(
      computed(() => ({
        userId: user.value?.id as string
      }))
    )
    onResult(result => {
      if (result?.data?.favorites) {
        favorites_user.value = result.data.favorites
      }
    })

    const swiperMainOptions = {
      slidesPerView: 1,
      spaceBetween: 0,
      loop: false,
      pagination: {
        el: '.swiper-pagination',
        clickable: true
      }
    }
    return { favorites_user, swiperMainOptions }
  }
})
</script>

<style lang="scss" scoped>
.page-title {
  margin-bottom: 40px;
  letter-spacing: -1px;
  color: #fff;
  font-size: 40px;
  line-height: 40px;
  font-weight: bold;
}
.grid {
  &-content {
    display: grid;
    grid-template-columns: 1fr;
    grid-row-gap: 10px;
    @media (min-width: 575.98px) {
      grid-template-columns: 1fr 1fr;
      grid-row-gap: 30px;
      grid-column-gap: 30px;
    }
    @media (min-width: 991.98px) {
      grid-template-columns: 1fr 1fr 1fr;
      grid-row-gap: 35px;
      grid-column-gap: 35px;
    }
  }
  &-item {
    background: #272c3b;
    border-radius: 10px;
    overflow: hidden;
    display: flex;
    flex-direction: column;
    &__top {
      flex: none;
      height: 280px;
      position: relative;
      background: rgba(#7683ad, 0.15);
      > a {
        position: absolute;
        left: 0px;
        right: 0px;
        top: 0px;
        bottom: 0px;
        z-index: 2;
      }
      &.none-photo {
        display: flex;
        align-items: center;
        justify-content: center;
        svg {
          width: 50px;
          height: 50px;
          fill: #7683ad;
        }
      }
    }
    &__gallery {
      width: 100%;
      height: 100%;
      &::v-deep {
        .blurhash {
          padding: 0 !important;
          height: 250px;
          @media (min-width: 991.98px) {
            height: 280px;
          }
        }
      }
    }
    &__bottom {
      flex: 1;
      padding: 25px 30px;
      display: flex;
      flex-direction: column;
      justify-content: center;
    }
    &__title {
      letter-spacing: 0px;
      color: #ffffff;
      font-weight: bold;
      font-size: 28px;
      line-height: 28px;
      margin-bottom: 10px;
      &:last-child {
        margin-bottom: 0px;
      }
    }
    &__place {
      display: inline-flex;
      align-items: center;
      color: #ffffff;
      font-size: 20px;
      line-height: 24px;
      font-weight: 500;
      margin-bottom: 15px;
      &:last-child {
        margin-bottom: 0px;
      }
      svg {
        width: 20px;
        height: 20px;
        margin-right: 10px;
        fill: #8591ad;
      }
    }
  }
}
</style>
